searchNodes=[{"doc":"A subdomain-safe name generator. Check out the README to get started.","ref":"Namor.html","title":"Namor","type":"module"},{"doc":"Generates a random name from a Namor dictionary. Returns {:ok, name} for a successfully generated name, or {:error, reason} if something goes wrong. See Custom Dictionaries for instructions on how to use a custom dictionary. Options :words - Number of words to generate. Must be &lt;=4. Defaults to 2 . :salt - Length of the salt to append. Must be &gt;=0. Defaults to 0 . :salt_type - Whether the salt should contain numbers, letters, or both. Defaults to :mixed . :separator - String to use as a separator between words. Defaults to - . :dictionary - Namor dictionary to use. Defaults to :default . Error Reasons :dict_not_found - Could not find the specified dictionary. Example iex&gt; require Namor Namor iex&gt; Namor . generate ( words : 3 , dictionary : :rugged ) { :ok , &quot;savage-whiskey-stain&quot; }","ref":"Namor.html#generate/1","title":"Namor.generate/1","type":"macro"},{"doc":"Generates a random name from a custom dictionary. Returns {:ok, name} for a successfully generated name. Takes the same options as generate/1 with the exception of :dictionary .","ref":"Namor.html#generate/2","title":"Namor.generate/2","type":"function"},{"doc":"Get Namor's dictionaries.","ref":"Namor.html#get_dictionaries/0","title":"Namor.get_dictionaries/0","type":"function"},{"doc":"Get Namor's reserved word list.","ref":"Namor.html#get_reserved/0","title":"Namor.get_reserved/0","type":"function"},{"doc":"Checks whether a value exists in Namor's list of reserved words. See reserved?/2 for more info. See Custom Dictionaries for instructions on how to use a custom reserved word list.","ref":"Namor.html#reserved?/1","title":"Namor.reserved?/1","type":"macro"},{"doc":"Checks whether a value exists in a provided list of reserved words. Before checking, the value is stripped of all special characters. So for example, log-in will still return true if [&quot;login&quot;] is passed to reserved .","ref":"Namor.html#reserved?/2","title":"Namor.reserved?/2","type":"function"},{"doc":"Checks whether a given value is a valid subdomain. Valid subdomains contain no special characters other than - , and are 63 characters or less.","ref":"Namor.html#subdomain?/1","title":"Namor.subdomain?/1","type":"function"},{"doc":"Appends a salt to a value. If you want to use a custom charlist for the salt, use Namor.Helpers.get_salt/2 instead.","ref":"Namor.html#with_salt/4","title":"Namor.with_salt/4","type":"function"},{"doc":"","ref":"Namor.html#t:dictionary_type/0","title":"Namor.dictionary_type/0","type":"type"},{"doc":"","ref":"Namor.html#t:salt_type/0","title":"Namor.salt_type/0","type":"type"},{"doc":"","ref":"Namor.Dictionary.html","title":"Namor.Dictionary","type":"module"},{"doc":"","ref":"Namor.Dictionary.html#t:t/0","title":"Namor.Dictionary.t/0","type":"type"},{"doc":"Supporting functions for dictionaries and name generation.","ref":"Namor.Helpers.html","title":"Namor.Helpers","type":"module"},{"doc":"Reads word lists from a base folder and returns a parsed dictionary map. A dictionary folder is expected to be a directory containing three files: adjectives.txt , nouns.txt , and verbs.txt . Each file should have one word per line with no duplicate words. If the dictionary name is set to a string, it will only attempt to read the one file and return a single list instead of a map. Raises a File.Error exception if any of the dictionary files are not found. ┌ ─ ─ reserved . txt ├ ─ ─ foobar / │ ┌ ─ ─ adjectives . txt │ ├ ─ ─ nouns . txt │ └ ─ ─ verbs . txt iex&gt; Namor.Helpers . get_dict ( &quot;reserved.txt&quot; ) [ &quot;foo&quot; , &quot;bar&quot; ] iex&gt; Namor.Helpers . get_dict ( :foobar ) %{ adjectives : [ &quot;foo&quot; ] , nouns : [ &quot;bar&quot; ] , verbs : [ &quot;baz&quot; ] } If not provided, base_path will fallback to Namor's internal dictionary path.","ref":"Namor.Helpers.html#get_dict!/2","title":"Namor.Helpers.get_dict!/2","type":"function"},{"doc":"Returns a word pattern for adjectives, nouns, and verbs in the proper order. Only supports patterns with a size up to 4. iex&gt; Namor.Helpers . get_pattern ( 4 ) [ :adjectives , :nouns , :nouns , :verbs ]","ref":"Namor.Helpers.html#get_pattern/1","title":"Namor.Helpers.get_pattern/1","type":"function"},{"doc":"Generates a random salt from a character list that can be appended to a name for uniqueness.","ref":"Namor.Helpers.html#get_salt/2","title":"Namor.Helpers.get_salt/2","type":"function"},{"doc":"Namor is a name generator for Elixir that creates random, url-friendly names. This comes in handy if you need to generate unique subdomains like many PaaS/SaaS providers do, or unique names for anything else. Supports compile-time dictionary loading, subdomain validation with reserved names, custom dictionaries and reserved word lists, alternate dictionaries, and more. See a demo here. Also available for Javascript . Please Note: Generated names are not always guaranteed to be unique. To reduce the chances of collision, you can increase the length of the trailing number ( see here for collision stats ). Always be sure to check your database before assuming a generated value is unique. Installation Getting Started Collision Stats Custom Dictionaries","ref":"readme.html","title":"Namor","type":"extras"},{"doc":"def deps do [ { :namor , &quot;~&gt; 1.0&quot; } ] end","ref":"readme.html#installation","title":"Namor - Installation","type":"extras"},{"doc":"iex&gt; require Namor iex&gt; Namor . generate ( ) { :ok , &quot;sandwich-invent&quot; } iex&gt; Namor . generate ( salt : 5 ) { :ok , &quot;sandwich-invent-s86uo&quot; } iex&gt; Namor . generate ( words : 3 , dictionary : :rugged ) { :ok , &quot;savage-whiskey-stain&quot; } An example module that generates subdomains for users (does not check for database uniqueness): defmodule MyApp.Subdomains do use Namor @salt_length 5 def get_new_subdomain ( nil ) , do : Namor . generate ( salt : @salt_length ) def get_new_subdomain ( name ) do with false &lt;- Namor . reserved? ( name ) , subdomain &lt;- Namor . with_salt ( name , @salt_length ) , true &lt;- Namor . subdomain? ( subdomain ) do { :ok , subdomain } else _ -&gt; { :error , :invalid_subdomain } end end end","ref":"readme.html#getting-started","title":"Namor - Getting Started","type":"extras"},{"doc":"The following stats give you the total number of permutations based on the word count (without a salt), and can help you make a decision on how long to make your salt. This data is based on the number of words we currently have in our dictionary files . :default dictionary 1-word combinations: 7,948 2-word combinations: 11,386,875 3-word combinations: 12,382,548,750 4-word combinations: 23,217,278,906,250 :rugged dictionary 1-word combinations: 735 2-word combinations: 127,400 3-word combinations: 14,138,880 4-word combinations: 3,958,886,400","ref":"readme.html#collision-stats","title":"Namor - Collision Stats","type":"extras"},{"doc":"In order for our dictionary files to be loaded into your application during compilation, generate/1 and reserved?/1 are defined as a macros. This means they can only be used after calling use Namor or require Namor , which should be done during compilation (and not inside a function). If you want to use your own dictionary, consider calling Namor.Helpers.get_dict!/2 in a place that executes during compilation and not runtime. For example: ┌ ─ ─ dictionaries / │ ┌ ─ ─ foobar / │ │ ┌ ─ ─ adjectives . txt │ │ ├ ─ ─ nouns . txt │ │ └ ─ ─ verbs . txt │ └ ─ ─ reserved . txt defmodule MyApp.Subdomains do use Namor @salt_length 5 @base_path Path . expand ( &quot;./dictionaries&quot; , __DIR__ ) @reserved Namor.Helpers . get_dict! ( &quot;reserved.txt&quot; , @base_path ) @dictionary Namor.Helpers . get_dict! ( :foobar , @base_path ) defp reserved , do : @reserved defp dictionary , do : @dictionary def get_new_subdomain ( nil ) , do : Namor . generate ( [ salt : @salt_length ] , dictionary ( ) ) def get_new_subdomain ( name ) do with false &lt;- Namor . reserved? ( name , reserved ( ) ) , subdomain &lt;- Namor . with_salt ( name , @salt_length ) , true &lt;- Namor . subdomain? ( subdomain ) do { :ok , subdomain } else _ -&gt; { :error , :invalid_subdomain } end end end","ref":"readme.html#custom-dictionaries","title":"Namor - Custom Dictionaries","type":"extras"}]